/*

<Aicaca Community Messenger Client>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using System.Data;
using System.Threading;
using System.Runtime.Serialization.Formatters.Binary;

namespace TalkClient
{
    delegate void GridDelegate();

	public class WinBoard : System.Windows.Forms.Form
	{
		private WinCom WC = new WinCom();
		private WinClient xWinClient;

        private string rootID;
		private string localID;

		private string boardID;
		private string boardName;
		private string boardPassword;
		private string boardType;

		private string msgID;
		private string msgPassword;

		private enum ActionMode {Msg, Write, Modify, Reply}
		private ActionMode actionMode = new ActionMode();

		private string searchKeyword;
		private string searchType;

        private DataTable xDataTable = new DataTable("board");
		private GridDelegate xGridDelegate;

		private System.Windows.Forms.Panel listPanel;
		private System.Windows.Forms.GroupBox actionGroup;
		private System.Windows.Forms.Button writeButton;
		private System.Windows.Forms.DataGrid mainGrid;
		private System.Windows.Forms.Panel inputPanel;
		private System.Windows.Forms.GroupBox bottomGroup;
		private System.Windows.Forms.Label msgLabel;
		private System.Windows.Forms.Label pwdLabel;
		private System.Windows.Forms.Label emailLabel;
		private System.Windows.Forms.Label writerLabel;
		private System.Windows.Forms.Label titleLabel;
		private System.Windows.Forms.TextBox titleBox;
		private System.Windows.Forms.TextBox writerBox;
		private System.Windows.Forms.TextBox pwdBox;
		private System.Windows.Forms.RichTextBox msgBox;
		private System.Windows.Forms.TextBox emailBox;
		private System.Windows.Forms.GroupBox topGroup;
		private System.Windows.Forms.TextBox countBox;
		private System.Windows.Forms.Label countLabel;
		private System.Windows.Forms.Button listButton;
		private System.Windows.Forms.Button saveButton;
		private System.Windows.Forms.Button resetButton;
		private System.Windows.Forms.Button replyButton;
		private System.Windows.Forms.Button modifyButton;
		private System.Windows.Forms.Button deleteButton;
		private System.Windows.Forms.DataGridTableStyle tableStyle;
		private System.Windows.Forms.DataGridTextBoxColumn titleStyle;
		private System.Windows.Forms.DataGridTextBoxColumn writerStyle;
		private System.Windows.Forms.DataGridTextBoxColumn emailStyle;
		private System.Windows.Forms.DataGridTextBoxColumn hitStyle;
		private System.Windows.Forms.DataGridTextBoxColumn dateStyle;
		private System.Windows.Forms.DataGridTextBoxColumn idStyle;
		private System.Windows.Forms.DataGridTextBoxColumn stepStyle;
		private System.Windows.Forms.Button adminButton;
		private System.Windows.Forms.GroupBox searchGroup;
		private System.Windows.Forms.TextBox searchBox;
		private System.Windows.Forms.Button searchButton;
		private System.Windows.Forms.Button allButton;
		private System.Windows.Forms.ComboBox typeCombo;
		private System.Windows.Forms.Label uploadLabel;
		private System.Windows.Forms.TextBox uploadBox;
		private System.Windows.Forms.Button uploadButton;
		private System.Windows.Forms.OpenFileDialog openDialog;
		private System.Windows.Forms.DataGridTextBoxColumn uploadStyle;
		private System.Windows.Forms.SaveFileDialog saveDialog;
		private System.Windows.Forms.ContextMenu editMenu;
		private System.ComponentModel.Container components = null;

		public WinBoard(WinClient tWinClient, string tLocalID, string tRootID, string tBoardID, string tBoardName, string tBoardPassword, string tBoardType)
		{
            xWinClient = tWinClient;
			localID = tLocalID;
			rootID = tRootID;
			boardID = tBoardID;
			boardName = tBoardName;
		    boardPassword = tBoardPassword;
			boardType = tBoardType;
		}

		public void WinThread()
		{
			xWinClient.AddThread(WC.MakeXML("WinBoard", boardID), this);
			InitializeComponent();
			this.SetConfig();
			this.ShowDialog();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.idStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.uploadLabel = new System.Windows.Forms.Label();
			this.searchButton = new System.Windows.Forms.Button();
			this.writeButton = new System.Windows.Forms.Button();
			this.countBox = new System.Windows.Forms.TextBox();
			this.writerLabel = new System.Windows.Forms.Label();
			this.titleBox = new System.Windows.Forms.TextBox();
			this.listPanel = new System.Windows.Forms.Panel();
			this.searchGroup = new System.Windows.Forms.GroupBox();
			this.allButton = new System.Windows.Forms.Button();
			this.searchBox = new System.Windows.Forms.TextBox();
			this.typeCombo = new System.Windows.Forms.ComboBox();
			this.actionGroup = new System.Windows.Forms.GroupBox();
			this.countLabel = new System.Windows.Forms.Label();
			this.adminButton = new System.Windows.Forms.Button();
			this.mainGrid = new System.Windows.Forms.DataGrid();
			this.tableStyle = new System.Windows.Forms.DataGridTableStyle();
			this.stepStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.titleStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.writerStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.emailStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.uploadStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.hitStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.dateStyle = new System.Windows.Forms.DataGridTextBoxColumn();
			this.inputPanel = new System.Windows.Forms.Panel();
			this.bottomGroup = new System.Windows.Forms.GroupBox();
			this.uploadButton = new System.Windows.Forms.Button();
			this.uploadBox = new System.Windows.Forms.TextBox();
			this.msgLabel = new System.Windows.Forms.Label();
			this.pwdLabel = new System.Windows.Forms.Label();
			this.emailLabel = new System.Windows.Forms.Label();
			this.titleLabel = new System.Windows.Forms.Label();
			this.writerBox = new System.Windows.Forms.TextBox();
			this.pwdBox = new System.Windows.Forms.TextBox();
			this.msgBox = new System.Windows.Forms.RichTextBox();
			this.editMenu = new System.Windows.Forms.ContextMenu();
			this.emailBox = new System.Windows.Forms.TextBox();
			this.topGroup = new System.Windows.Forms.GroupBox();
			this.deleteButton = new System.Windows.Forms.Button();
			this.modifyButton = new System.Windows.Forms.Button();
			this.replyButton = new System.Windows.Forms.Button();
			this.listButton = new System.Windows.Forms.Button();
			this.saveButton = new System.Windows.Forms.Button();
			this.resetButton = new System.Windows.Forms.Button();
			this.saveDialog = new System.Windows.Forms.SaveFileDialog();
			this.openDialog = new System.Windows.Forms.OpenFileDialog();
			this.listPanel.SuspendLayout();
			this.searchGroup.SuspendLayout();
			this.actionGroup.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.mainGrid)).BeginInit();
			this.inputPanel.SuspendLayout();
			this.bottomGroup.SuspendLayout();
			this.topGroup.SuspendLayout();
			this.SuspendLayout();
			// 
			// idStyle
			// 
			this.idStyle.Format = "";
			this.idStyle.FormatInfo = null;
			this.idStyle.HeaderText = "Record ID";
			this.idStyle.MappingName = "recordID";
			this.idStyle.Width = 0;
			// 
			// uploadLabel
			// 
			this.uploadLabel.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.uploadLabel.Location = new System.Drawing.Point(8, 256);
			this.uploadLabel.Name = "uploadLabel";
			this.uploadLabel.Size = new System.Drawing.Size(64, 23);
			this.uploadLabel.TabIndex = 0;
			this.uploadLabel.Text = "Upload";
			this.uploadLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// searchButton
			// 
			this.searchButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.searchButton.Location = new System.Drawing.Point(392, 16);
			this.searchButton.Name = "searchButton";
			this.searchButton.Size = new System.Drawing.Size(80, 23);
			this.searchButton.TabIndex = 7;
			this.searchButton.Text = "Search";
			this.searchButton.Click += new System.EventHandler(this.searchButton_Click);
			// 
			// writeButton
			// 
			this.writeButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.writeButton.Location = new System.Drawing.Point(392, 16);
			this.writeButton.Name = "writeButton";
			this.writeButton.Size = new System.Drawing.Size(80, 24);
			this.writeButton.TabIndex = 2;
			this.writeButton.Text = "Write";
			this.writeButton.Click += new System.EventHandler(this.writeButton_Click);
			// 
			// countBox
			// 
			this.countBox.Anchor = System.Windows.Forms.AnchorStyles.Left;
			this.countBox.Location = new System.Drawing.Point(96, 16);
			this.countBox.Name = "countBox";
			this.countBox.ReadOnly = true;
			this.countBox.Size = new System.Drawing.Size(80, 21);
			this.countBox.TabIndex = 0;
			this.countBox.Text = "0";
			// 
			// writerLabel
			// 
			this.writerLabel.Location = new System.Drawing.Point(8, 48);
			this.writerLabel.Name = "writerLabel";
			this.writerLabel.Size = new System.Drawing.Size(64, 23);
			this.writerLabel.TabIndex = 0;
			this.writerLabel.Text = "Writer";
			this.writerLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// titleBox
			// 
			this.titleBox.Location = new System.Drawing.Point(80, 16);
			this.titleBox.MaxLength = 100;
			this.titleBox.Name = "titleBox";
			this.titleBox.Size = new System.Drawing.Size(392, 21);
			this.titleBox.TabIndex = 7;
			this.titleBox.Text = "";
			// 
			// listPanel
			// 
			this.listPanel.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.listPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.searchGroup,
																					this.actionGroup,
																					this.mainGrid});
			this.listPanel.Location = new System.Drawing.Point(8, 8);
			this.listPanel.Name = "listPanel";
			this.listPanel.Size = new System.Drawing.Size(480, 352);
			this.listPanel.TabIndex = 0;
			// 
			// searchGroup
			// 
			this.searchGroup.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.searchGroup.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.allButton,
																					  this.searchButton,
																					  this.searchBox,
																					  this.typeCombo});
			this.searchGroup.Location = new System.Drawing.Point(0, 296);
			this.searchGroup.Name = "searchGroup";
			this.searchGroup.Size = new System.Drawing.Size(480, 48);
			this.searchGroup.TabIndex = 0;
			this.searchGroup.TabStop = false;
			this.searchGroup.Text = "Search";
			// 
			// allButton
			// 
			this.allButton.Anchor = System.Windows.Forms.AnchorStyles.Left;
			this.allButton.Location = new System.Drawing.Point(8, 16);
			this.allButton.Name = "allButton";
			this.allButton.Size = new System.Drawing.Size(80, 23);
			this.allButton.TabIndex = 4;
			this.allButton.Text = "Refresh All";
			this.allButton.Click += new System.EventHandler(this.allButton_Click);
			// 
			// searchBox
			// 
			this.searchBox.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.searchBox.Location = new System.Drawing.Point(256, 16);
			this.searchBox.MaxLength = 30;
			this.searchBox.Name = "searchBox";
			this.searchBox.Size = new System.Drawing.Size(128, 21);
			this.searchBox.TabIndex = 6;
			this.searchBox.Text = "";
			// 
			// typeCombo
			// 
			this.typeCombo.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.typeCombo.DropDownWidth = 121;
			this.typeCombo.Items.AddRange(new object[] {
														   "Tilte",
														   "Writer",
														   "Message"});
			this.typeCombo.Location = new System.Drawing.Point(144, 16);
			this.typeCombo.Name = "typeCombo";
			this.typeCombo.Size = new System.Drawing.Size(104, 20);
			this.typeCombo.TabIndex = 5;
			this.typeCombo.Text = "Select Type";
			// 
			// actionGroup
			// 
			this.actionGroup.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.actionGroup.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.countLabel,
																					  this.countBox,
																					  this.adminButton,
																					  this.writeButton});
			this.actionGroup.Name = "actionGroup";
			this.actionGroup.Size = new System.Drawing.Size(480, 48);
			this.actionGroup.TabIndex = 0;
			this.actionGroup.TabStop = false;
			this.actionGroup.Text = "Action";
			// 
			// countLabel
			// 
			this.countLabel.Anchor = System.Windows.Forms.AnchorStyles.Left;
			this.countLabel.Location = new System.Drawing.Point(8, 24);
			this.countLabel.Name = "countLabel";
			this.countLabel.Size = new System.Drawing.Size(88, 16);
			this.countLabel.TabIndex = 0;
			this.countLabel.Text = "Count of rows";
			this.countLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// adminButton
			// 
			this.adminButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.adminButton.Location = new System.Drawing.Point(304, 16);
			this.adminButton.Name = "adminButton";
			this.adminButton.Size = new System.Drawing.Size(80, 24);
			this.adminButton.TabIndex = 1;
			this.adminButton.Text = "Admin";
			this.adminButton.Click += new System.EventHandler(this.adminButton_Click);
			// 
			// mainGrid
			// 
			this.mainGrid.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.mainGrid.CaptionVisible = false;
			this.mainGrid.DataMember = "";
			this.mainGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.mainGrid.Location = new System.Drawing.Point(0, 56);
			this.mainGrid.Name = "mainGrid";
			this.mainGrid.ReadOnly = true;
			this.mainGrid.Size = new System.Drawing.Size(480, 232);
			this.mainGrid.TabIndex = 3;
			this.mainGrid.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
																								 this.tableStyle});
			this.mainGrid.MouseDown += new System.Windows.Forms.MouseEventHandler(this.mainGrid_Click);
			// 
			// tableStyle
			// 
			this.tableStyle.DataGrid = this.mainGrid;
			this.tableStyle.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
																										 this.idStyle,
																										 this.stepStyle,
																										 this.titleStyle,
																										 this.writerStyle,
																										 this.emailStyle,
																										 this.uploadStyle,
																										 this.hitStyle,
																										 this.dateStyle});
			this.tableStyle.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.tableStyle.MappingName = "board";
			this.tableStyle.RowHeadersVisible = false;
			// 
			// stepStyle
			// 
			this.stepStyle.Format = "";
			this.stepStyle.FormatInfo = null;
			this.stepStyle.HeaderText = "Step";
			this.stepStyle.MappingName = "step";
			this.stepStyle.Width = 0;
			// 
			// titleStyle
			// 
			this.titleStyle.Format = "";
			this.titleStyle.FormatInfo = null;
			this.titleStyle.HeaderText = "Title";
			this.titleStyle.MappingName = "title";
			this.titleStyle.Width = 300;
			// 
			// writerStyle
			// 
			this.writerStyle.Format = "";
			this.writerStyle.FormatInfo = null;
			this.writerStyle.HeaderText = "Writer";
			this.writerStyle.MappingName = "writer";
			this.writerStyle.Width = 75;
			// 
			// emailStyle
			// 
			this.emailStyle.Format = "";
			this.emailStyle.FormatInfo = null;
			this.emailStyle.HeaderText = "Email";
			this.emailStyle.MappingName = "email";
			this.emailStyle.Width = 20;
			// 
			// uploadStyle
			// 
			this.uploadStyle.Format = "";
			this.uploadStyle.FormatInfo = null;
			this.uploadStyle.HeaderText = "File";
			this.uploadStyle.MappingName = "upload";
			this.uploadStyle.Width = 20;
			// 
			// hitStyle
			// 
			this.hitStyle.Format = "";
			this.hitStyle.FormatInfo = null;
			this.hitStyle.HeaderText = "Hit";
			this.hitStyle.MappingName = "hit";
			this.hitStyle.Width = 20;
			// 
			// dateStyle
			// 
			this.dateStyle.Format = "";
			this.dateStyle.FormatInfo = null;
			this.dateStyle.HeaderText = "Date";
			this.dateStyle.MappingName = "createdDate";
			this.dateStyle.Width = 20;
			// 
			// inputPanel
			// 
			this.inputPanel.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.inputPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.bottomGroup,
																					 this.topGroup});
			this.inputPanel.Location = new System.Drawing.Point(8, 8);
			this.inputPanel.Name = "inputPanel";
			this.inputPanel.Size = new System.Drawing.Size(480, 352);
			this.inputPanel.TabIndex = 0;
			this.inputPanel.Visible = false;
			// 
			// bottomGroup
			// 
			this.bottomGroup.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.bottomGroup.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.uploadButton,
																					  this.uploadBox,
																					  this.uploadLabel,
																					  this.msgLabel,
																					  this.pwdLabel,
																					  this.emailLabel,
																					  this.writerLabel,
																					  this.titleLabel,
																					  this.titleBox,
																					  this.writerBox,
																					  this.pwdBox,
																					  this.msgBox,
																					  this.emailBox});
			this.bottomGroup.Location = new System.Drawing.Point(0, 56);
			this.bottomGroup.Name = "bottomGroup";
			this.bottomGroup.Size = new System.Drawing.Size(480, 288);
			this.bottomGroup.TabIndex = 0;
			this.bottomGroup.TabStop = false;
			this.bottomGroup.Text = "Contents";
			// 
			// uploadButton
			// 
			this.uploadButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.uploadButton.Location = new System.Drawing.Point(368, 256);
			this.uploadButton.Name = "uploadButton";
			this.uploadButton.Size = new System.Drawing.Size(96, 23);
			this.uploadButton.TabIndex = 13;
			this.uploadButton.Click += new System.EventHandler(this.uploadButton_Click);
			// 
			// uploadBox
			// 
			this.uploadBox.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.uploadBox.Location = new System.Drawing.Point(80, 256);
			this.uploadBox.MaxLength = 300;
			this.uploadBox.Name = "uploadBox";
			this.uploadBox.Size = new System.Drawing.Size(280, 21);
			this.uploadBox.TabIndex = 12;
			this.uploadBox.Text = "";
			// 
			// msgLabel
			// 
			this.msgLabel.Location = new System.Drawing.Point(8, 112);
			this.msgLabel.Name = "msgLabel";
			this.msgLabel.Size = new System.Drawing.Size(64, 23);
			this.msgLabel.TabIndex = 0;
			this.msgLabel.Text = "Message";
			this.msgLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// pwdLabel
			// 
			this.pwdLabel.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.pwdLabel.Location = new System.Drawing.Point(8, 224);
			this.pwdLabel.Name = "pwdLabel";
			this.pwdLabel.Size = new System.Drawing.Size(64, 23);
			this.pwdLabel.TabIndex = 0;
			this.pwdLabel.Text = "Password";
			this.pwdLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// emailLabel
			// 
			this.emailLabel.Location = new System.Drawing.Point(8, 80);
			this.emailLabel.Name = "emailLabel";
			this.emailLabel.Size = new System.Drawing.Size(64, 23);
			this.emailLabel.TabIndex = 0;
			this.emailLabel.Text = "E-mail";
			this.emailLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// titleLabel
			// 
			this.titleLabel.Location = new System.Drawing.Point(8, 16);
			this.titleLabel.Name = "titleLabel";
			this.titleLabel.Size = new System.Drawing.Size(64, 23);
			this.titleLabel.TabIndex = 0;
			this.titleLabel.Text = "Title";
			this.titleLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// writerBox
			// 
			this.writerBox.Location = new System.Drawing.Point(80, 48);
			this.writerBox.MaxLength = 50;
			this.writerBox.Name = "writerBox";
			this.writerBox.Size = new System.Drawing.Size(192, 21);
			this.writerBox.TabIndex = 8;
			this.writerBox.Text = "";
			// 
			// pwdBox
			// 
			this.pwdBox.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.pwdBox.Location = new System.Drawing.Point(80, 224);
			this.pwdBox.MaxLength = 20;
			this.pwdBox.Name = "pwdBox";
			this.pwdBox.Size = new System.Drawing.Size(96, 21);
			this.pwdBox.TabIndex = 11;
			this.pwdBox.Text = "";
			// 
			// msgBox
			// 
			this.msgBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.msgBox.BackColor = System.Drawing.SystemColors.Window;
			this.msgBox.ContextMenu = this.editMenu;
			this.msgBox.DetectUrls = false;
			this.msgBox.Location = new System.Drawing.Point(80, 112);
			this.msgBox.MaxLength = 1000000;
			this.msgBox.Name = "msgBox";
			this.msgBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.ForcedVertical;
			this.msgBox.Size = new System.Drawing.Size(392, 104);
			this.msgBox.TabIndex = 10;
			this.msgBox.Text = "";
			// 
			// emailBox
			// 
			this.emailBox.Location = new System.Drawing.Point(80, 80);
			this.emailBox.MaxLength = 100;
			this.emailBox.Name = "emailBox";
			this.emailBox.Size = new System.Drawing.Size(192, 21);
			this.emailBox.TabIndex = 9;
			this.emailBox.Text = "";
			// 
			// topGroup
			// 
			this.topGroup.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.topGroup.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.deleteButton,
																				   this.modifyButton,
																				   this.replyButton,
																				   this.listButton,
																				   this.saveButton,
																				   this.resetButton});
			this.topGroup.Name = "topGroup";
			this.topGroup.Size = new System.Drawing.Size(480, 48);
			this.topGroup.TabIndex = 0;
			this.topGroup.TabStop = false;
			this.topGroup.Text = "Action";
			// 
			// deleteButton
			// 
			this.deleteButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.deleteButton.Location = new System.Drawing.Point(408, 16);
			this.deleteButton.Name = "deleteButton";
			this.deleteButton.Size = new System.Drawing.Size(64, 24);
			this.deleteButton.TabIndex = 6;
			this.deleteButton.Text = "Delete";
			this.deleteButton.Click += new System.EventHandler(this.deleteButton_Click);
			// 
			// modifyButton
			// 
			this.modifyButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.modifyButton.Location = new System.Drawing.Point(336, 16);
			this.modifyButton.Name = "modifyButton";
			this.modifyButton.Size = new System.Drawing.Size(64, 24);
			this.modifyButton.TabIndex = 5;
			this.modifyButton.Text = "Modify";
			this.modifyButton.Click += new System.EventHandler(this.modifyButton_Click);
			// 
			// replyButton
			// 
			this.replyButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.replyButton.Location = new System.Drawing.Point(264, 16);
			this.replyButton.Name = "replyButton";
			this.replyButton.Size = new System.Drawing.Size(64, 24);
			this.replyButton.TabIndex = 4;
			this.replyButton.Text = "Reply";
			this.replyButton.Click += new System.EventHandler(this.replyButton_Click);
			// 
			// listButton
			// 
			this.listButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.listButton.Location = new System.Drawing.Point(48, 16);
			this.listButton.Name = "listButton";
			this.listButton.Size = new System.Drawing.Size(64, 24);
			this.listButton.TabIndex = 1;
			this.listButton.Text = "List";
			this.listButton.Click += new System.EventHandler(this.listButton_Click);
			// 
			// saveButton
			// 
			this.saveButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.saveButton.Location = new System.Drawing.Point(120, 16);
			this.saveButton.Name = "saveButton";
			this.saveButton.Size = new System.Drawing.Size(64, 24);
			this.saveButton.TabIndex = 2;
			this.saveButton.Text = "Save";
			this.saveButton.Click += new System.EventHandler(this.saveButton_Click);
			// 
			// resetButton
			// 
			this.resetButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
			this.resetButton.Location = new System.Drawing.Point(192, 16);
			this.resetButton.Name = "resetButton";
			this.resetButton.Size = new System.Drawing.Size(64, 24);
			this.resetButton.TabIndex = 3;
			this.resetButton.Text = "Reset";
			this.resetButton.Click += new System.EventHandler(this.resetButton_Click);
			// 
			// saveDialog
			// 
			this.saveDialog.FileOk += new System.ComponentModel.CancelEventHandler(this.saveDialogButton_Click);
			// 
			// WinBoard
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(496, 357);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.inputPanel,
																		  this.listPanel});
			this.Name = "WinBoard";
			this.Text = "Aicaca WinBoard";
			this.Load += new System.EventHandler(this.this_Load);
			this.Closed += new System.EventHandler(this.this_Closed);
			this.listPanel.ResumeLayout(false);
			this.searchGroup.ResumeLayout(false);
			this.actionGroup.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.mainGrid)).EndInit();
			this.inputPanel.ResumeLayout(false);
			this.bottomGroup.ResumeLayout(false);
			this.topGroup.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void this_Load(object sender, System.EventArgs e)
		{
			this.ListProcess();
		}

		private void this_Closed(object sender, System.EventArgs e)
		{
			xWinClient.RemoveThread(WC.MakeXML("WinBoard", boardID));
		}

		private void adminButton_Click(object sender, System.EventArgs e)
		{
			new WinBoardPassword(this);
		}

		private void writeButton_Click (object sender, System.EventArgs e)
		{
			actionMode = ActionMode.Write;

			this.titleBox.Text = "";
			this.writerBox.Text = "";
			this.emailBox.Text = "";
			this.msgBox.Text = "";
			this.pwdBox.Text = "";
			this.uploadBox.Text = "";

			this.titleBox.ReadOnly = false;
			this.writerBox.ReadOnly = false;
			this.emailBox.ReadOnly = false;
			this.msgBox.ReadOnly = false;
			this.msgBox.BackColor = Color.White;
			this.pwdBox.ReadOnly = false;
			this.uploadBox.ReadOnly = false;

			this.saveButton.Enabled = true;
			this.resetButton.Enabled = true;
			this.replyButton.Enabled = false;
			this.modifyButton.Enabled = false;
			this.deleteButton.Enabled = false;

			this.uploadButton.Enabled = true;
			this.uploadButton.Text = "Select File";

			this.editMenu.MenuItems[0].Enabled = true;
            this.editMenu.MenuItems[1].Enabled = true;
            this.editMenu.MenuItems[2].Enabled = true;

			this.listPanel.Visible = false;
			this.inputPanel.Visible = true;
		}

		private void listButton_Click(object sender, System.EventArgs e)
		{
			this.listPanel.Visible = true;
			this.inputPanel.Visible = false;
		}

		private void saveButton_Click(object sender, System.EventArgs e)
		{
			string titleStr = this.titleBox.Text;
			string writerStr = this.writerBox.Text;
			string emailStr = this.emailBox.Text;
			string msgStr = this.msgBox.Text;
			string pwdStr = this.pwdBox.Text;
			string ipStr = WC.GetXML(this.localID, "li");
			string fileStr = this.uploadBox.Text;

			if (titleStr.Length == 0 || writerStr.Length == 0 || emailStr.Length == 0 || msgStr.Length == 0 || pwdStr.Length == 0)
			{
				MessageBox.Show(WC.lineStr8);
				return;
			}
			else
			{
				if (fileStr.Length > 0)
				{
					try
					{
						FileStream fs = new FileStream(fileStr, FileMode.Open);
						int fileLen = Convert.ToInt32(fs.Length);
						fs.Close();

						if (fileLen > 300000)
						{
							MessageBox.Show(this, WC.lineStr19);
							return;
						}
					}
					catch (Exception ex)
					{
						MessageBox.Show(this, WC.lineStr18);
						return;
					}
				}

				if (actionMode == ActionMode.Write)
				{
					this.WriteProcess(titleStr, writerStr, emailStr, msgStr, pwdStr, ipStr, fileStr);
				}
				else if (actionMode == ActionMode.Reply)
				{
					this.ReplyProcess(titleStr, writerStr, emailStr, msgStr, pwdStr, ipStr, fileStr);
				}
				else if (actionMode == ActionMode.Modify)
				{
					this.ModifyProcess(titleStr, writerStr, emailStr, msgStr, pwdStr, ipStr);
				}
			}
		}

		private void resetButton_Click(object sender, System.EventArgs e)
		{
			this.titleBox.Text = "";
			this.writerBox.Text = "";
			this.emailBox.Text = "";
			this.msgBox.Text = "";
			this.pwdBox.Text = "";
		}

		private void modifyButton_Click(object sender, System.EventArgs e)
		{
			if (this.pwdBox.Text.Length > 0)
			{
				if (this.pwdBox.Text == this.msgPassword)
				{
                    actionMode = ActionMode.Modify;

					this.titleBox.ReadOnly = false;
					this.writerBox.ReadOnly = false;
					this.emailBox.ReadOnly = false;
					this.msgBox.ReadOnly = false;
                    this.msgBox.BackColor = Color.White;
					this.pwdBox.ReadOnly = false;

					this.saveButton.Enabled = true;
					this.resetButton.Enabled = true;
					this.replyButton.Enabled = false;
					this.modifyButton.Enabled = false;
					this.deleteButton.Enabled = false;

					this.uploadButton.Enabled = false;
					this.uploadButton.Text = "Select File";

					this.editMenu.MenuItems[0].Enabled = true;
					this.editMenu.MenuItems[1].Enabled = true;
					this.editMenu.MenuItems[2].Enabled = true;
				}
				else
				{
					MessageBox.Show(this, WC.lineStr6);
				}
			}
			else
			{
				MessageBox.Show(this, WC.lineStr7);
			}
		}

		private void replyButton_Click(object sender, System.EventArgs e)
		{
			actionMode = ActionMode.Reply;

			this.writerBox.Text = "";
			this.emailBox.Text = "";
			this.msgBox.Text = "";
			this.pwdBox.Text = "";

			this.titleBox.ReadOnly = false;
			this.writerBox.ReadOnly = false;
			this.emailBox.ReadOnly = false;
			this.msgBox.ReadOnly = false;
            this.msgBox.BackColor = Color.White;
			this.pwdBox.ReadOnly = false;
			this.uploadBox.ReadOnly = false;

			this.saveButton.Enabled = true;
			this.resetButton.Enabled = true;
			this.replyButton.Enabled = false;
			this.modifyButton.Enabled = false;
			this.deleteButton.Enabled = false;

			this.uploadButton.Enabled = true;
			this.uploadButton.Text = "Select File";

			this.editMenu.MenuItems[0].Enabled = true;
			this.editMenu.MenuItems[1].Enabled = true;
			this.editMenu.MenuItems[2].Enabled = true;
		}

		private void deleteButton_Click(object sender, System.EventArgs e)
		{
			if (this.pwdBox.Text.Length > 0)
			{
				if (this.pwdBox.Text == this.msgPassword)
				{
					this.listPanel.Visible = true;
					this.inputPanel.Visible = false;

					this.DeleteProcess();
				}
				else
				{
					MessageBox.Show(this, WC.lineStr6);
				}
			}
			else
			{
				MessageBox.Show(this, WC.lineStr7);
			}
		}

		private void searchButton_Click(object sender, System.EventArgs e)
		{
			int index = this.typeCombo.SelectedIndex;

			if (index != -1)
			{
				if (this.searchBox.Text.Length > 0)
				{
                    this.searchKeyword = this.searchBox.Text;

					if (index == 0) this.searchType = "title";
					else if (index == 1) this.searchType = "writer";
					else if (index == 2) this.searchType = "msg";

					this.SearchProcess();
					this.searchBox.Text = "";
				}
				else
				{
					MessageBox.Show(this, WC.lineStr17);
				}
			}
			else
			{
				MessageBox.Show(this, WC.lineStr16);
			}
		}

		private void allButton_Click(object sender, System.EventArgs e)
		{
			this.ListProcess();
		}

		private void uploadButton_Click(object sender, System.EventArgs e)
		{
			if (actionMode == ActionMode.Write || actionMode == ActionMode.Reply)
			{
				openDialog.Title = "Select File";
				openDialog.InitialDirectory = "C:\\";
				openDialog.ShowDialog();
				uploadBox.Text = openDialog.FileName;
			}
			else if (actionMode == ActionMode.Msg)
			{
				saveDialog.FileName = this.uploadBox.Text;
                saveDialog.ShowDialog();
			}
		}

		private void saveDialogButton_Click (object sender, System.ComponentModel.CancelEventArgs e)
		{
			string originFileName = this.uploadBox.Text;
			string changeFileName = saveDialog.FileName;

			string sendStr = WC.MakeXML("ms", "ILOVEAICACABFI") + localID + rootID + WC.MakeXML("xo", originFileName) + WC.MakeXML("xc", changeFileName);
			xWinClient.SendRootMsg(sendStr);
		}

		private void mainGrid_Click(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			DataGrid myGrid = (DataGrid) sender;
			System.Windows.Forms.DataGrid.HitTestInfo hti = myGrid.HitTest(e.X, e.Y);

			if (hti.Type == System.Windows.Forms.DataGrid.HitTestType.Cell)
			{
				actionMode = ActionMode.Msg;

				this.titleBox.Text = "";
				this.writerBox.Text = "";
				this.emailBox.Text = "";
				this.msgBox.Text = "";
				this.pwdBox.Text = "";
				this.uploadBox.Text = "";

				this.titleBox.ReadOnly = true;
				this.writerBox.ReadOnly = true;
				this.emailBox.ReadOnly = true;
				this.msgBox.ReadOnly = true;
				this.msgBox.BackColor = Color.LightBlue;
				this.pwdBox.ReadOnly = false;
				this.uploadBox.ReadOnly = true;

				if (boardType == "Notice")
				{
					this.saveButton.Enabled = false;
					this.resetButton.Enabled = false;
					this.pwdBox.Enabled = false;
					this.replyButton.Enabled = false;
					this.modifyButton.Enabled = false;
					this.deleteButton.Enabled = false;
				}
				else
				{
					this.saveButton.Enabled = false;
					this.resetButton.Enabled = false;
					this.replyButton.Enabled = true;
					this.modifyButton.Enabled = true;
					this.deleteButton.Enabled = true;
					this.pwdBox.Enabled = true;
				}

				this.editMenu.MenuItems[0].Enabled = false;
				this.editMenu.MenuItems[1].Enabled = true;
				this.editMenu.MenuItems[2].Enabled = false;

				this.listPanel.Visible = false;
				this.inputPanel.Visible = true;

				this.MsgProcess(this.mainGrid[hti.Row, 0].ToString());
			}
		}

		private void Cut_Clicked(object sender, System.EventArgs e)
		{
			msgBox.Cut();
		}

		private void Copy_Clicked(object sender, System.EventArgs e)
		{
			msgBox.Copy();
		}

		private void Paste_Clicked(object sender, System.EventArgs e)
		{
			msgBox.Paste();
		}

		private void SetConfig()
		{
			this.editMenu.MenuItems.Add(0, new MenuItem("Cut", new EventHandler(this.Cut_Clicked), Shortcut.CtrlX));
			this.editMenu.MenuItems.Add(1, new MenuItem("Copy", new EventHandler(this.Copy_Clicked), Shortcut.CtrlC));
			this.editMenu.MenuItems.Add(2, new MenuItem("Paste", new EventHandler(this.Paste_Clicked), Shortcut.CtrlV));

			if (boardType == "Notice") this.writeButton.Enabled = false;
			if (boardType == "Common") this.adminButton.Enabled = false;

			xDataTable.Columns.Add("recordID");
			xDataTable.Columns.Add("step");
			xDataTable.Columns.Add("title");
			xDataTable.Columns.Add("writer");
			xDataTable.Columns.Add("email");
			xDataTable.Columns.Add("upload");
			xDataTable.Columns.Add("hit");
			xDataTable.Columns.Add("createdDate");

			this.xGridDelegate = new GridDelegate(this.SetGrid);
		}

		private void SetGrid()
		{
			this.mainGrid.DataSource = this.xDataTable;
		}

		private void SetForm()
		{
			this.countBox.Text = "Waiting...";
			this.Update();
			this.searchKeyword = "";
			this.mainGrid.DataSource = null;
			this.xDataTable.Rows.Clear();
		}

		private void ListProcess()
		{
            this.SetForm();

			string sendStr = WC.MakeXML("ms", "ILOVEAICACABLI") + localID + rootID + WC.MakeXML("xs", boardID);
			xWinClient.SendRootMsg(sendStr);
		}

		private void MsgProcess(string str)
		{
			string sendStr = WC.MakeXML("ms", "ILOVEAICACABME") + localID + rootID + WC.MakeXML("xs", boardID) + WC.MakeXML("xi", str);
			xWinClient.SendRootMsg(sendStr);
		}

		private void WriteProcess(string titleStr, string writerStr, string emailStr, string msgStr, string pwdStr, string ipStr, string fileStr)
		{
			this.SetForm();

			string sendStr = "";
            string fileProtocol = "";
			int len = 0;
			int fileLen = 0;
            byte[] sendStream = null;
			byte[] fileStream = null;

			if (fileStr.Length > 0)
			{
				FileStream fs = new FileStream(fileStr, FileMode.Open);
				fileLen = Convert.ToInt32(fs.Length);

				fileStream = new byte[fileLen];
				fs.Read(fileStream,0,fileLen);
				fs.Close();

				fileProtocol = WC.MakeXML("xf", fileStr) + WC.MakeXML("xn", fileLen.ToString());
			}

			MemoryStream stream = new MemoryStream();
			XmlTextWriter xw = new XmlTextWriter(stream, System.Text.Encoding.UTF8);

			xw.WriteStartElement("record");
			xw.WriteElementString("title", titleStr);
			xw.WriteElementString("writer", writerStr);
			xw.WriteElementString("email", emailStr);
			xw.WriteElementString("msg", msgStr);
			xw.WriteElementString("pwd", pwdStr);
			xw.WriteElementString("remoteIP", ipStr);
			xw.WriteEndElement();
			xw.Flush();
			xw.Close();

			sendStream = stream.ToArray();
			len = sendStream.Length;
			sendStr = WC.MakeXML("ms", "ILOVEAICACABSA") + localID + rootID + WC.MakeXML("xs", boardID) + WC.MakeXML("xl", len.ToString()) + fileProtocol;
			
			xWinClient.SendRootMsg(sendStr);
			xWinClient.SendRootStream(sendStream);
			if (fileStream != null) xWinClient.SendRootStream(fileStream);

			this.titleBox.Text = "";
			this.writerBox.Text = "";
			this.emailBox.Text = "";
			this.msgBox.Text = "";
			this.pwdBox.Text = "";
			this.uploadBox.Text = "";

			this.listPanel.Visible = true;
			this.inputPanel.Visible = false;
		}

		private void ReplyProcess(string titleStr, string writerStr, string emailStr, string msgStr, string pwdStr, string ipStr, string fileStr)
		{
			this.SetForm();

			string sendStr = "";
            string fileProtocol = "";
			int len = 0;
            int fileLen = 0;
			byte[] sendStream = null;
			byte[] fileStream = null;

			if (fileStr.Length > 0)
			{
				FileStream fs = new FileStream(fileStr, FileMode.Open);
				fileLen = Convert.ToInt32(fs.Length);

				fileStream = new byte[fileLen];
				fs.Read(fileStream,0,fileLen);
				fs.Close();

				fileProtocol = WC.MakeXML("xf", fileStr) + WC.MakeXML("xn", fileLen.ToString());
			}

			MemoryStream stream = new MemoryStream();
			XmlTextWriter xw = new XmlTextWriter(stream, System.Text.Encoding.UTF8);

			xw.WriteStartElement("record");
			xw.WriteElementString("title", titleStr);
			xw.WriteElementString("writer", writerStr);
			xw.WriteElementString("email", emailStr);
			xw.WriteElementString("msg", msgStr);
			xw.WriteElementString("pwd", pwdStr);
			xw.WriteElementString("remoteIP", ipStr);
			xw.WriteEndElement();
			xw.Flush();
			xw.Close();

			sendStream = stream.ToArray();
			len = sendStream.Length;
			sendStr = WC.MakeXML("ms", "ILOVEAICACABRE") + localID + rootID + WC.MakeXML("xs", boardID) + WC.MakeXML("xl", len.ToString()) + WC.MakeXML("xi", msgID) + fileProtocol;
			
			xWinClient.SendRootMsg(sendStr);
			xWinClient.SendRootStream(sendStream);
			if (fileStream != null) xWinClient.SendRootStream(fileStream);

			this.titleBox.Text = "";
			this.writerBox.Text = "";
			this.emailBox.Text = "";
			this.msgBox.Text = "";
			this.pwdBox.Text = "";
			this.uploadBox.Text = "";

			this.listPanel.Visible = true;
			this.inputPanel.Visible = false;
		}

		private void ModifyProcess(string titleStr, string writerStr, string emailStr, string msgStr, string pwdStr, string ipStr)
		{
			this.SetForm();

			string sendStr = "";
			int len = 0;
			byte[] sendStream = null;

			MemoryStream stream = new MemoryStream();
			XmlTextWriter xw = new XmlTextWriter(stream, System.Text.Encoding.UTF8);

			xw.WriteStartElement("record");
			xw.WriteElementString("title", titleStr);
			xw.WriteElementString("writer", writerStr);
			xw.WriteElementString("email", emailStr);
			xw.WriteElementString("msg", msgStr);
			xw.WriteElementString("pwd", pwdStr);
			xw.WriteElementString("remoteIP", ipStr);
			xw.WriteEndElement();
			xw.Flush();
			xw.Close();

			sendStream = stream.ToArray();
			len = sendStream.Length;
			sendStr = WC.MakeXML("ms", "ILOVEAICACABMO") + localID + rootID + WC.MakeXML("xs", boardID) + WC.MakeXML("xl", len.ToString()) + WC.MakeXML("xi", msgID);
			
			xWinClient.SendRootMsg(sendStr);
			xWinClient.SendRootStream(sendStream);

			this.titleBox.Text = "";
			this.writerBox.Text = "";
			this.emailBox.Text = "";
			this.msgBox.Text = "";
			this.pwdBox.Text = "";
			this.uploadBox.Text = "";

			this.listPanel.Visible = true;
			this.inputPanel.Visible = false;
		}

		private void DeleteProcess()
		{
			this.SetForm();

			string sendStr = WC.MakeXML("ms", "ILOVEAICACABDE") + localID + rootID + WC.MakeXML("xs", boardID) + WC.MakeXML("xi", msgID);
			xWinClient.SendRootMsg(sendStr);
		}

		private void SearchProcess()
		{
			this.countBox.Text = "Waiting...";
			this.Update();
            this.mainGrid.DataSource = null;
			this.xDataTable.Rows.Clear();

			string sendStr = WC.MakeXML("ms", "ILOVEAICACABSE") + localID + rootID + WC.MakeXML("xs", boardID) + WC.MakeXML("xt", searchType) + WC.MakeXML("xk", searchKeyword);
			xWinClient.SendRootMsg(sendStr);
		}

		public void CheckPassword(string str)
		{
			if (str == this.boardPassword)
			{
				this.boardType = "Common";
				this.writeButton.Enabled = true;
			}
		}

		public void OnILOVEAICACAXLI(string sort, byte[] getStream)
		{
			if (getStream != null)
			{
				XmlDocument xd = new XmlDocument();
				xd.Load(new MemoryStream(getStream));

				XmlTextReader xr = new XmlTextReader(new StringReader(xd.OuterXml));
				XmlDataDocument dd = new XmlDataDocument();
				dd.DataSet.ReadXml(xr, XmlReadMode.InferSchema);
				DataTable dt = dd.DataSet.Tables[0];

				int rowCount = dt.Rows.Count;
				int step = 1;
				string prefix = "";
				string upload = "";

				for (int i=0 ; i < rowCount ; i++)
				{
					DataRow dr = this.xDataTable.NewRow();

					dr["recordID"] = dt.Rows[i]["recordID"];
					dr["writer"] = dt.Rows[i]["writer"];
					dr["email"] = dt.Rows[i]["email"];
					dr["hit"] = dt.Rows[i]["hit"];
					dr["createdDate"] = dt.Rows[i]["createdDate"];

					prefix = "";
					step = Convert.ToInt32(dt.Rows[i]["step"]);
					if (step > 1)
					{
						for (int j=1 ; j < step ; j++) prefix += "  ";
						prefix += "[RE]";
					}
					dr["step"] = step.ToString();
					dr["title"] = prefix + dt.Rows[i]["title"];

					upload = dt.Rows[i]["upload"].ToString();
					if (upload == "N/A") upload = "";
					dr["upload"] = upload;

					xDataTable.Rows.Add(dr);
				}

				try
				{
					this.countBox.Text = rowCount.ToString();
					this.Invoke(this.xGridDelegate);
				}
				catch (Exception e)
				{
					MessageBox.Show(e.ToString());
				}
			}
			else
			{
				this.countBox.Text = "No Results";
			}
		}

		public void OnILOVEAICACAXME(string sort, byte[] getStream)
		{
			XmlDocument dd = new XmlDocument();
			dd.Load(new MemoryStream(getStream));

			this.msgID = dd.SelectSingleNode("record/recordID").InnerText;
			this.msgPassword = dd.SelectSingleNode("record/pwd").InnerText;

			this.titleBox.Text = dd.SelectSingleNode("record/title").InnerText;
			this.writerBox.Text = dd.SelectSingleNode("record/writer").InnerText;
			this.emailBox.Text = dd.SelectSingleNode("record/email").InnerText;
			this.pwdBox.Text = "";

            string msgStr = dd.SelectSingleNode("record/msg").InnerText;
			string uploadStr = dd.SelectSingleNode("record/upload").InnerText;
            
			if (searchKeyword.Length > 0 && searchType == "msg")
			{
				string msgUpper = msgStr.ToUpper();
				int firstPos = 0;
				int secondPos = -1;

				while ((secondPos = msgUpper.IndexOf(searchKeyword.ToUpper(), secondPos+1)) != -1)
				{
					string str = msgStr.Substring(firstPos, secondPos-firstPos);
					this.msgBox.AppendText(str);
					this.msgBox.SelectionColor = Color.Red;
					this.msgBox.SelectionFont = new Font("Arial", 9, FontStyle.Bold);
                    string key = msgStr.Substring(secondPos, searchKeyword.Length);
					this.msgBox.AppendText(key);
					this.msgBox.SelectionColor = Color.Black;
					this.msgBox.SelectionFont = new Font("Arial", 9);

					firstPos = secondPos + searchKeyword.Length;
				}

				this.msgBox.AppendText(msgStr.Substring(firstPos, msgStr.Length-firstPos));
			}
			else
			{
				this.msgBox.AppendText(msgStr);
			}


			if (uploadStr == "N/A")
			{
				uploadStr = "";
				this.uploadButton.Enabled = false;
				this.uploadButton.Text = "Save File";
                this.uploadBox.Text = uploadStr;
			}
			else
			{
				this.uploadButton.Enabled = true;
				this.uploadButton.Text = "Save File";
                this.uploadBox.Text = uploadStr;
			}
		}
	}
}
