/*

<Aicaca Community Messenger Client>

Copyright (c) Aicaca.com, All rights reserved.

Writer                : Byung-ku, Cho (Aicaca)
E-mail                : aicaca@hanmail.net
Personal Homepage URL : http://www.aicaca.com
Last Updated Date     : Feb. 27th, 2002

Programming Language  : C#
Editor & Compiler     : VisualStudio.NET

*/


using System;
using System.IO;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.Xml;

namespace TalkClient
{
	public class WinClient : System.Windows.Forms.Form
	{
		private WinCom WC = new WinCom();
		private WinAccept xWinAccept = null;
		private WinRoot xWinRoot = null;

		private Hashtable FormHash = new Hashtable();

		private Socket RootSocket = null;
		private TextWriter SocketWriter = null;

		private string clientAddr;
		private string configData;
		private string clientVersion;
		private string rootID;
		private string localID;

		private bool shutFlag = false;

		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.NotifyIcon onTrayIcon;
		private System.Windows.Forms.NotifyIcon offTrayIcon;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem actionMenu;
		private System.Windows.Forms.MenuItem configMenu;
		private System.Windows.Forms.MenuItem startMenu;
		private System.Windows.Forms.MenuItem stopMenu;
		private System.Windows.Forms.MenuItem hideMenu;
		private System.Windows.Forms.MenuItem shutMenu;
		private System.Windows.Forms.MenuItem helpMenu;
		private System.Windows.Forms.MenuItem aboutMenu;
		private System.Windows.Forms.ToolBar toolBar;
		private System.Windows.Forms.ToolBarButton configBtn;
		private System.Windows.Forms.ToolBarButton startBtn;
		private System.Windows.Forms.ToolBarButton stopBtn;
		private System.Windows.Forms.ToolBarButton hideBtn;
		private System.Windows.Forms.ToolBarButton shutBtn;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.StatusBarPanel mainStatus;
		private System.Windows.Forms.ListView clientList;
		private System.Windows.Forms.ColumnHeader idColumn;
		private System.Windows.Forms.ColumnHeader ipColumn;
		private System.Windows.Forms.ColumnHeader portColumn;
		private System.Windows.Forms.ListView boardList;
		private System.Windows.Forms.ColumnHeader nameColumn;
		private System.Windows.Forms.ColumnHeader typeColumn;
		private System.Windows.Forms.TextBox chatBox;
		private System.Windows.Forms.Button sendButton;
		private System.Windows.Forms.TextBox inputBox;
		private System.Windows.Forms.StatusBarPanel processStatus;

		public WinClient()
		{
			this.InitializeComponent();
			this.InitializeClient();
		}

		protected override void Dispose(bool disposing)
		{
			if (shutFlag == true)
			{
				if( disposing )
				{
					if(components != null)
					{
						components.Dispose();
					}
				}
				base.Dispose( disposing );
			}
			else
			{
				this.Visible = false;
			}
		}

        #region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(WinClient));
			this.onTrayIcon = new System.Windows.Forms.NotifyIcon(this.components);
			this.offTrayIcon = new System.Windows.Forms.NotifyIcon(this.components);
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.actionMenu = new System.Windows.Forms.MenuItem();
			this.configMenu = new System.Windows.Forms.MenuItem();
			this.startMenu = new System.Windows.Forms.MenuItem();
			this.stopMenu = new System.Windows.Forms.MenuItem();
			this.hideMenu = new System.Windows.Forms.MenuItem();
			this.shutMenu = new System.Windows.Forms.MenuItem();
			this.helpMenu = new System.Windows.Forms.MenuItem();
			this.aboutMenu = new System.Windows.Forms.MenuItem();
			this.toolBar = new System.Windows.Forms.ToolBar();
			this.configBtn = new System.Windows.Forms.ToolBarButton();
			this.startBtn = new System.Windows.Forms.ToolBarButton();
			this.stopBtn = new System.Windows.Forms.ToolBarButton();
			this.hideBtn = new System.Windows.Forms.ToolBarButton();
			this.shutBtn = new System.Windows.Forms.ToolBarButton();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.mainStatus = new System.Windows.Forms.StatusBarPanel();
			this.processStatus = new System.Windows.Forms.StatusBarPanel();
			this.clientList = new System.Windows.Forms.ListView();
			this.idColumn = new System.Windows.Forms.ColumnHeader();
			this.ipColumn = new System.Windows.Forms.ColumnHeader();
			this.portColumn = new System.Windows.Forms.ColumnHeader();
			this.boardList = new System.Windows.Forms.ListView();
			this.nameColumn = new System.Windows.Forms.ColumnHeader();
			this.typeColumn = new System.Windows.Forms.ColumnHeader();
			this.chatBox = new System.Windows.Forms.TextBox();
			this.inputBox = new System.Windows.Forms.TextBox();
			this.sendButton = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.mainStatus)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.processStatus)).BeginInit();
			this.SuspendLayout();
			// 
			// onTrayIcon
			// 
			this.onTrayIcon.Icon = ((System.Drawing.Icon)(resources.GetObject("onTrayIcon.Icon")));
			this.onTrayIcon.Text = "Connected";
			this.onTrayIcon.Visible = true;
			this.onTrayIcon.DoubleClick += new System.EventHandler(this.TrayIcon_DoubleClick);
			// 
			// offTrayIcon
			// 
			this.offTrayIcon.Icon = ((System.Drawing.Icon)(resources.GetObject("offTrayIcon.Icon")));
			this.offTrayIcon.Text = "Disconnected";
			this.offTrayIcon.DoubleClick += new System.EventHandler(this.TrayIcon_DoubleClick);
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.actionMenu,
																					 this.helpMenu});
			// 
			// actionMenu
			// 
			this.actionMenu.Index = 0;
			this.actionMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.configMenu,
																					   this.startMenu,
																					   this.stopMenu,
																					   this.hideMenu,
																					   this.shutMenu});
			this.actionMenu.Text = "Action";
			// 
			// configMenu
			// 
			this.configMenu.Index = 0;
			this.configMenu.Text = "Config";
			this.configMenu.Click += new System.EventHandler(this.configMenu_Click);
			// 
			// startMenu
			// 
			this.startMenu.Enabled = false;
			this.startMenu.Index = 1;
			this.startMenu.Text = "Client Start";
			this.startMenu.Click += new System.EventHandler(this.startMenu_Click);
			// 
			// stopMenu
			// 
			this.stopMenu.Index = 2;
			this.stopMenu.Text = "Client Stop";
			this.stopMenu.Click += new System.EventHandler(this.stopMenu_Click);
			// 
			// hideMenu
			// 
			this.hideMenu.Index = 3;
			this.hideMenu.Text = "Hide";
			this.hideMenu.Click += new System.EventHandler(this.hideMenu_Click);
			// 
			// shutMenu
			// 
			this.shutMenu.Index = 4;
			this.shutMenu.Text = "Shut Down";
			this.shutMenu.Click += new System.EventHandler(this.shutMenu_Click);
			// 
			// helpMenu
			// 
			this.helpMenu.Index = 1;
			this.helpMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.aboutMenu});
			this.helpMenu.Text = "Help";
			// 
			// aboutMenu
			// 
			this.aboutMenu.Index = 0;
			this.aboutMenu.Text = "About Aicaca Client";
			this.aboutMenu.Click += new System.EventHandler(this.aboutMenu_Click);
			// 
			// toolBar
			// 
			this.toolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.configBtn,
																					   this.startBtn,
																					   this.stopBtn,
																					   this.hideBtn,
																					   this.shutBtn});
			this.toolBar.ButtonSize = new System.Drawing.Size(80, 35);
			this.toolBar.DropDownArrows = true;
			this.toolBar.Name = "toolBar";
			this.toolBar.ShowToolTips = true;
			this.toolBar.Size = new System.Drawing.Size(600, 38);
			this.toolBar.TabIndex = 1;
			this.toolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar_ButtonClick);
			// 
			// configBtn
			// 
			this.configBtn.Text = "Config";
			// 
			// startBtn
			// 
			this.startBtn.Enabled = false;
			this.startBtn.Text = "Client Start";
			// 
			// stopBtn
			// 
			this.stopBtn.Text = "Client Stop";
			// 
			// hideBtn
			// 
			this.hideBtn.Text = "Hide";
			// 
			// shutBtn
			// 
			this.shutBtn.Text = "Shut Down";
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 328);
			this.statusBar.Name = "statusBar";
			this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						 this.mainStatus,
																						 this.processStatus});
			this.statusBar.ShowPanels = true;
			this.statusBar.Size = new System.Drawing.Size(600, 22);
			this.statusBar.TabIndex = 0;
			// 
			// mainStatus
			// 
			this.mainStatus.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.mainStatus.Width = 384;
			// 
			// processStatus
			// 
			this.processStatus.Width = 200;
			// 
			// clientList
			// 
			this.clientList.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.clientList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.idColumn,
																						 this.ipColumn,
																						 this.portColumn});
			this.clientList.Location = new System.Drawing.Point(0, 40);
			this.clientList.Name = "clientList";
			this.clientList.Size = new System.Drawing.Size(254, 144);
			this.clientList.TabIndex = 2;
			this.clientList.View = System.Windows.Forms.View.Details;
			this.clientList.DoubleClick += new System.EventHandler(this.clientList_DoubleClick);
			// 
			// idColumn
			// 
			this.idColumn.Text = "User ID";
			this.idColumn.Width = 80;
			// 
			// ipColumn
			// 
			this.ipColumn.Text = "IP";
			this.ipColumn.Width = 120;
			// 
			// portColumn
			// 
			this.portColumn.Text = "Port";
			this.portColumn.Width = 50;
			// 
			// boardList
			// 
			this.boardList.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.boardList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.nameColumn,
																						this.typeColumn});
			this.boardList.Location = new System.Drawing.Point(0, 184);
			this.boardList.Name = "boardList";
			this.boardList.Size = new System.Drawing.Size(254, 144);
			this.boardList.TabIndex = 3;
			this.boardList.View = System.Windows.Forms.View.Details;
			this.boardList.DoubleClick += new System.EventHandler(this.boardList_DoubleClick);
			// 
			// nameColumn
			// 
			this.nameColumn.Text = "Board Name";
			this.nameColumn.Width = 150;
			// 
			// typeColumn
			// 
			this.typeColumn.Text = "Board Type";
			this.typeColumn.Width = 100;
			// 
			// chatBox
			// 
			this.chatBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.chatBox.Location = new System.Drawing.Point(256, 40);
			this.chatBox.MaxLength = 10000000;
			this.chatBox.Multiline = true;
			this.chatBox.Name = "chatBox";
			this.chatBox.ReadOnly = true;
			this.chatBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.chatBox.Size = new System.Drawing.Size(344, 240);
			this.chatBox.TabIndex = 0;
			this.chatBox.Text = "";
			// 
			// inputBox
			// 
			this.inputBox.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.inputBox.Location = new System.Drawing.Point(256, 280);
			this.inputBox.MaxLength = 1000;
			this.inputBox.Multiline = true;
			this.inputBox.Name = "inputBox";
			this.inputBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.inputBox.Size = new System.Drawing.Size(280, 48);
			this.inputBox.TabIndex = 4;
			this.inputBox.Text = "";
			// 
			// sendButton
			// 
			this.sendButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.sendButton.Location = new System.Drawing.Point(536, 280);
			this.sendButton.Name = "sendButton";
			this.sendButton.Size = new System.Drawing.Size(64, 48);
			this.sendButton.TabIndex = 5;
			this.sendButton.Text = "Send";
			this.sendButton.Click += new System.EventHandler(this.sendButton_Click);
			// 
			// WinClient
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(600, 350);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.sendButton,
																		  this.inputBox,
																		  this.chatBox,
																		  this.boardList,
																		  this.clientList,
																		  this.statusBar,
																		  this.toolBar});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "WinClient";
			this.Text = "Aicaca Client";
			((System.ComponentModel.ISupportInitialize)(this.mainStatus)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.processStatus)).EndInit();
			this.ResumeLayout(false);

		}
        #endregion

		private void configMenu_Click(object sender, System.EventArgs e)
		{
		    new WinConfig(this);
		}

		private void startMenu_Click(object sender, System.EventArgs e)
		{
		    this.StartAll();
		}

		private void stopMenu_Click(object sender, System.EventArgs e)
		{
		    this.StopAll();
		}

		private void hideMenu_Click(object sender, System.EventArgs e)
		{
		    this.Visible = false;
		}

		private void shutMenu_Click(object sender, System.EventArgs e)
		{
		    this.ShutDown();
		}

		private void aboutMenu_Click(object sender, System.EventArgs e)
		{
		    System.Diagnostics.Process.Start("IEXPLORE.EXE", "www.aicaca.com");
		}

		private void sendButton_Click(object sender, System.EventArgs e)
		{
			if (this.inputBox.Text.Length > 0)
			{
				string sendStr = WC.MakeXML("ms", "ILOVEAICACACHA") + localID + rootID + "<body>" + this.inputBox.Text;
				this.SendRootMsg(sendStr);
			}
			this.inputBox.Text = "";
			this.inputBox.Focus();
		}

		private void toolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			string str = e.Button.Text;

			switch(str)
			{
				case "Config":
					new WinConfig(this);
					break;
				case "Client Start":
					this.StartAll();
					break;
				case "Client Stop":
					this.StopAll();
					break;
				case "Hide":
					this.Visible = false;
					break;
				case "Shut Down":
					this.ShutDown();
					break;
			}
		}

		private void clientList_DoubleClick (object sender, System.EventArgs e)
		{
			string clientName = clientList.SelectedItems[0].SubItems[0].Text;
			string clientIP = clientList.SelectedItems[0].SubItems[1].Text;
			string clientPort = clientList.SelectedItems[0].SubItems[2].Text;
			string clientID = WC.MakeClientID("WinClient", clientName, clientIP, clientPort);

			this.StartWinDialog_Connect(clientID);
		}

		private void boardList_DoubleClick (object sender, System.EventArgs e)
		{
			string boardName = this.boardList.SelectedItems[0].Text;
			
			XmlDocument xd = new XmlDocument();
			xd.Load(new XmlTextReader(new StringReader(configData)));

			XmlNode xn = xd.SelectSingleNode("Config/BoardList/Board[BoardName='" + boardName + "']");
			string boardID = xn.SelectSingleNode("BoardID").InnerText;
			string boardPassword = xn.SelectSingleNode("BoardPassword").InnerText;
			string boardType = xn.SelectSingleNode("BoardType").InnerText;

			if (!FormHash.Contains(WC.MakeXML("WinBoard", boardID)))
			{
				this.StartWinBoard(boardID, boardName, boardPassword, boardType);
			}
		}

		private void TrayIcon_DoubleClick (object sender, System.EventArgs e)
		{
			this.Visible = true;
		}

		private void InitializeClient()
		{
			DirectoryInfo xDirInfo = new DirectoryInfo(WC.varStr1);
			if (!xDirInfo.Exists) xDirInfo.Create();

			if (System.IO.File.Exists(WC.varStr1 + "ClientConfig.xml") == false)
			{
				XmlTextWriter xw = new XmlTextWriter(WC.varStr1 + "ClientConfig.xml", null);

				xw.WriteStartElement("Config");
				xw.WriteStartElement("LocalID");
				xw.WriteElementString("LocalSort", "WinClient");
				xw.WriteElementString("LocalName", "");
				xw.WriteElementString("LocalPort", "1004");
				xw.WriteEndElement();
				xw.WriteStartElement("RootID");
				xw.WriteElementString("RootSort", "WinServer");
				xw.WriteElementString("RootName", "Root");
				xw.WriteElementString("RootIP", "");
				xw.WriteElementString("RootPort", "");
				xw.WriteEndElement();
				xw.WriteStartElement("Version");
				xw.WriteElementString("ClientVersion", "Ver1.2");
				xw.WriteEndElement();
				xw.WriteEndElement();
				xw.Flush();
				xw.Close();
			}

			XmlDocument xd = new XmlDocument();
			xd.Load(WC.varStr1 + "ClientConfig.xml");

			string localSort = xd.SelectSingleNode("Config/LocalID/LocalSort").InnerText;
			string localName = xd.SelectSingleNode("Config/LocalID/LocalName").InnerText;
			string localIP = Dns.GetHostByName(Dns.GetHostName()).AddressList[0].ToString();
			string localPort = xd.SelectSingleNode("Config/LocalID/LocalPort").InnerText;
			string rootSort = xd.SelectSingleNode("Config/RootID/RootSort").InnerText;
			string rootName = xd.SelectSingleNode("Config/RootID/RootName").InnerText;
			string rootIP = xd.SelectSingleNode("Config/RootID/RootIP").InnerText;
			string rootPort = xd.SelectSingleNode("Config/RootID/RootPort").InnerText;
			clientVersion = xd.SelectSingleNode("Config/Version/ClientVersion").InnerText;

			if (localName.Length == 0 || rootIP.Length == 0 || rootPort.Length == 0)
			{
				new WinConfig(this);
			}
			else
			{
				localID = WC.MakeLocalID(localSort, localName, localIP, localPort);
				rootID = WC.MakeRootID(rootSort, rootName, rootIP, rootPort);

				this.StartWinAccept();
			}
		}

		private void SetConfigData()
		{
			XmlDocument xd = new XmlDocument();
			xd.Load(new XmlTextReader(new StringReader(configData)));

			string version = xd.SelectSingleNode("Config/Version/ClientVersion").InnerText;

			if (version != clientVersion)
			{
				MessageBox.Show(this, WC.lineStr20 + version);
				//System.Diagnostics.Process.Start("AicacaUpdate.exe", version);
				this.ShutDown();
			}

			XmlNodeList xnl = xd.SelectNodes("Config/BoardList/Board");
				
			for (IEnumerator ie = xnl.GetEnumerator() ; ie.MoveNext() ;)
			{
				XmlNode xn = ((XmlNode)ie.Current);
				string[] strs = new string[2];
				strs[0] = xn.SelectSingleNode("BoardName").InnerText;
				strs[1] = xn.SelectSingleNode("BoardType").InnerText;

				this.boardList.Items.Add(new ListViewItem(strs));
			}
		}

		private void UpdateListBox()
		{
			int firstPos = -1;
			this.clientList.Items.Clear();

			while ((firstPos = clientAddr.IndexOf("<cid>", firstPos+1)) != -1)
			{
				string[] strs = new string[3];
				strs[0] = WC.GetXML(clientAddr, "cn", firstPos);
				strs[1] = WC.GetXML(clientAddr, "ci", firstPos);
				strs[2] = WC.GetXML(clientAddr, "cp", firstPos);

				this.clientList.Items.Add(new ListViewItem(strs));
			}
		}

		private void SendSocketMsg(Socket sk, string str)
		{
			str = WC.ReplaceStr(str, "\n", "&Line;") + "\n";

			if (sk != null && sk.Connected)
			{
				NetworkStream stream = new NetworkStream(sk);
				TextWriter tempWriter = new StreamWriter(stream);
				tempWriter.Write(str);
				tempWriter.Flush();
			}
		}

		private void AddChatText(string name, string str)
		{
			str = WC.ReplaceStr(str, "&Line;", "\n");

			if (this.chatBox.Text.Length == 0)
			{
				this.chatBox.Text = "[" + name + "]\r\n" + str + "\r\n\r\n";
			}
			else
			{
				this.chatBox.AppendText("[" + name + "]\r\n" + str + "\r\n\r\n");
			}
		}

		private void StartWinAccept()
		{
			xWinAccept = new WinAccept(this, localID, rootID);
			Thread ServerThread = new Thread(new ThreadStart(xWinAccept.ServerProc));
			ServerThread.Start();
		}

		private void StartWinBoard(string boardID, string boardName, string boardPassword, string boardType)
		{
			WinBoard xWinBoard = new WinBoard(this, localID, rootID, boardID, boardName, boardPassword, boardType);
			Thread BoardThread = new Thread(new ThreadStart(xWinBoard.WinThread));
			BoardThread.Start();
		}
       
		private void StartWinDialog_Connect(string clientID)
		{
			WinDialog xWinDialog = new WinDialog(this, localID, clientID);
			Thread ClientThread = new Thread(new ThreadStart(xWinDialog.WinThread_Connect));
			ClientThread.Start();
		}

		private void StartWinDialog_Accept(Socket sk, string clientID, string str)
		{
			WinDialog xWinDialog = new WinDialog(this, sk, localID, clientID, str);
			Thread ClientThread = new Thread(new ThreadStart(xWinDialog.WinThread_Accept));
			ClientThread.Start();
		}

		private void StartWinDialog_RoundMsg(string clientID, string str)
		{
			WinDialog xWinDialog = new WinDialog(this, localID, clientID, str);
			Thread ClientThread = new Thread(new ThreadStart(xWinDialog.WinThread_RoundMsg));
			ClientThread.Start();
		}

		private void StartWinReceive_Accept(Socket sk, string clientID, string str)
		{
			WinReceive xWinReceive = new WinReceive(this, sk, localID, clientID, str);
			Thread ClientThread = new Thread(new ThreadStart(xWinReceive.WinThread_Accept));
			ClientThread.Start();
		}

		private void StartWinReceive_RoundMsg(string clientID, string str)
		{
			WinReceive xWinReceive = new WinReceive(this, localID, clientID, str);
			Thread ClientThread = new Thread(new ThreadStart(xWinReceive.WinThread_RoundMsg));
			ClientThread.Start();
		}

		public void StartAll()
		{
			this.InitializeClient();

			this.startMenu.Enabled = false;
			this.startBtn.Enabled = false;
			this.stopMenu.Enabled = true;
			this.stopBtn.Enabled = true;

			onTrayIcon.Visible = true;
			offTrayIcon.Visible = false;
		}

		public void StopAll()
		{
			if (xWinAccept != null) xWinAccept.CloseThis();
			if (xWinRoot != null) xWinRoot.CloseThis();

			this.startMenu.Enabled = true;
			this.startBtn.Enabled = true;
			this.stopMenu.Enabled = false;
			this.stopBtn.Enabled = false;

			onTrayIcon.Visible = false;
			offTrayIcon.Visible = true;

			clientAddr = "";
			this.chatBox.Text = "";
			this.clientList.Items.Clear();
			this.boardList.Items.Clear();
		}

		public void ShutDown()
		{
			shutFlag = true;
			if (xWinAccept != null) xWinAccept.CloseThis();
			if (xWinRoot != null) xWinRoot.CloseThis();
			this.Close();
		}

		public void AddThread(string str, object o)
		{
			lock(this)
			{
				FormHash.Add(str, o);
			}
		}

		public void RemoveThread(string str)
		{
			lock(this)
			{
				FormHash.Remove(str);
			}
			
		}

		public bool CheckThread(string str)
		{
			lock(this)
			{
				if (FormHash.Contains(str))
				{
					return true;
				}
				else
				{
					return false;
				}
			}
		}

		public void SendRootMsg(string str)
		{
			lock(this)
			{
				str = WC.ReplaceStr(str, "\n", "&Line;") + "\n";

				if (RootSocket != null && RootSocket.Connected)
				{
					SocketWriter.Write(str);
					SocketWriter.Flush();
				}
				else
				{
					MessageBox.Show(this, WC.lineStr1);
				}
			}
		}

		public void SendRootStream(byte[] b)
		{
			lock(this)
			{
				if (RootSocket != null && RootSocket.Connected)
				{
					RootSocket.Send(b, b.Length, 0);
				}
			}
		}

		public void AcceptILOVEAICACAMSG(Socket sk, string str)
		{
			lock(this)
			{
				string otherRemoteName = WC.GetXML(str, "en");
				string otherRemoteIP = WC.GetXML(str, "ei");
				string otherRemotePort = WC.GetXML(str, "ep");
				string threadID = WC.MakeThreadID("WinDialog", otherRemoteName, otherRemoteIP, otherRemotePort);
				string clientID = WC.MakeClientID("WinClient", otherRemoteName, otherRemoteIP, otherRemotePort);

				if (FormHash.Contains(threadID))
				{
					WinDialog tWinDialog = (WinDialog)FormHash[threadID];
					tWinDialog.SetSocket(sk, true);
					tWinDialog.OnILOVEAICACAMSG(str);

				}
				else
				{
					this.StartWinDialog_Accept(sk, clientID, str);
				}
			}
		}

		//////////Sending Type//////////
		public void AcceptILOVEAICACAFAC(Socket sk, string str)
		{
			lock(this)
			{
				string threadID = WC.RemoteToThread(WC.GetXML(str, "eid"));
				string remoteID = WC.ThreadToRemote(WC.GetXML(str, "tid"));

				if (FormHash.Contains(threadID))
				{
					WinSend tWinSend = (WinSend)FormHash[threadID];
					tWinSend.SetSocket(sk, true);
					tWinSend.OnILOVEAICACAFAC(str);
				}
				else
				{
					string sendStr = WC.MakeXML("ms", "ILOVEAICACAERR") + threadID + remoteID + WC.MakeXML("er", WC.lineStr10);
					this.SendSocketMsg(sk, sendStr);
				}
			}
		}

		//////////Sending Type//////////
		public void AcceptILOVEAICACAFRE(string str)
		{
			lock(this)
			{
				string threadID = WC.RemoteToThread(WC.GetXML(str, "eid"));

				if (FormHash.Contains(threadID))
				{
					WinSend tWinSend = (WinSend)FormHash[threadID];
					tWinSend.OnILOVEAICACAFRE();
				}
			}
		}


		//////////Receivinging Type//////////
		public void AcceptILOVEAICACAFNO(Socket sk, string str)
		{
			lock(this)
			{
				string otherRemoteName = WC.GetXML(str, "en");
				string otherRemoteIP = WC.GetXML(str, "ei");
				string otherRemotePort = WC.GetXML(str, "ep");
				string clientID = WC.MakeClientID("WinClient", otherRemoteName, otherRemoteIP, otherRemotePort);

				this.StartWinReceive_Accept(sk, clientID, str);
			}
		}

		public void RootILOVEAICACACFG(string str)
		{
			configData = WC.MakeXML("Config", WC.GetXML(str, "Config"));
			this.SetConfigData();
		}

		public void RootILOVEAICACACAS(string str)
		{
			lock(this)
			{
				string preAddr = WC.GetXML(str, "car");
				string compareID = WC.LocalToClient(localID);

				clientAddr = WC.RemoveStr(preAddr, compareID);
				this.UpdateListBox();
			}
		}

		public void RootILOVEAICACAMSG(string str)
		{
			lock(this)
			{
				string otherRemoteName = WC.GetXML(str, "en");
				string otherRemoteIP = WC.GetXML(str, "ei");
				string otherRemotePort = WC.GetXML(str, "ep");
				string threadID = WC.MakeThreadID("WinDialog", otherRemoteName, otherRemoteIP, otherRemotePort);
				string clientID = WC.MakeClientID("WinClient", otherRemoteName, otherRemoteIP, otherRemotePort);

				if (FormHash.Contains(threadID))
				{
					((WinDialog)FormHash[threadID]).OnILOVEAICACAMSG(str);
				}
				else
				{
					this.StartWinDialog_RoundMsg(clientID, str);
				}
			}
		}

		//////////Sending Type//////////
		public void RootILOVEAICACAFAC(string str)
		{
			lock(this)
			{
				string threadID = WC.RemoteToThread(WC.GetXML(str, "eid"));
				string remoteID = WC.ThreadToRemote(WC.GetXML(str, "tid"));

				if (FormHash.Contains(threadID))
				{
					((WinSend)FormHash[threadID]).OnILOVEAICACAFAC(str);
				}
				else
				{
					string sendStr = WC.MakeXML("ms", "ILOVEAICACAERR") + threadID + remoteID + WC.MakeXML("er", WC.lineStr10);
					this.SendRootMsg(sendStr);
				}
			}
		}

		//////////Sending Type//////////
		public void RootILOVEAICACAFRE(string str)
		{
			lock(this)
			{
				string threadID = WC.RemoteToThread(WC.GetXML(str, "eid"));
			
				if (FormHash.Contains(threadID))
				{
					((WinSend)FormHash[threadID]).OnILOVEAICACAFRE();
				}
			}
		}

		//////////Receivinging Type//////////
		public void RootILOVEAICACAFNO(string str)
		{
			lock(this)
			{
				string otherRemoteName = WC.GetXML(str, "en");
				string otherRemoteIP = WC.GetXML(str, "ei");
				string otherRemotePort = WC.GetXML(str, "ep");
				string threadID = WC.MakeThreadID("WinReceive", otherRemoteName, otherRemoteIP, otherRemotePort);
				string clientID = WC.MakeClientID("WinClient", otherRemoteName, otherRemoteIP, otherRemotePort);
			
				if (FormHash.Contains(threadID))
				{
					((WinReceive)FormHash[threadID]).OnILOVEAICACAFNO(str);
				}
				else
				{
					this.StartWinReceive_RoundMsg(clientID, str);
				}
			}
		}

		//////////Receivinging Type//////////
		public void RootILOVEAICACAFCA(string str)
		{
			lock(this)
			{
				string threadID = WC.RemoteToThread(WC.GetXML(str, "eid"));
			
				if (FormHash.Contains(threadID))
				{
					((WinReceive)FormHash[threadID]).OnILOVEAICACAFCA();
				}
			}
		}

		//////////Receivinging Type//////////
		public void RootILOVEAICACAFIL(string str)
		{
			lock(this)
			{
				string threadID = WC.RemoteToThread(WC.GetXML(str, "eid"));
				string remoteID = WC.ThreadToRemote(WC.GetXML(str, "tid"));
			
				int fileLen = Convert.ToInt32(WC.GetXML(str, "fl"));
				byte[] fileStream = new byte[fileLen];

				int idx = 0;
				while (fileLen > idx)
				{
					idx = idx + RootSocket.Receive(fileStream, idx, fileLen-idx, 0);
				}

				if (FormHash.Contains(threadID))
				{
					((WinReceive)FormHash[threadID]).OnILOVEAICACAFIL(str, fileStream);
				}
				else
				{
					string sendStr = WC.MakeXML("ms", "ILOVEAICACAERR") + threadID + remoteID + WC.MakeXML("er", WC.lineStr10);
					this.SendRootMsg(sendStr);
				}
			}
		}

		public void RootILOVEAICACAXLI(string str)
		{
			lock(this)
			{
				string sort = WC.GetXML(str, "xs");
				int len = Convert.ToInt32(WC.GetXML(str, "xl"));
				byte[] getStream = null;
				int idx = 0;

				if (len > 0)
				{
					getStream = new byte[len];

					while (len > idx)
					{
						idx = idx + RootSocket.Receive(getStream, idx, len-idx, 0);
					}
				}

				if (FormHash.Contains(WC.MakeXML("WinBoard", sort)))
				{
					((WinBoard)FormHash[WC.MakeXML("WinBoard", sort)]).OnILOVEAICACAXLI(sort, getStream);
				}
			}
		}

		public void RootILOVEAICACAXME(string str)
		{
			lock(this)
			{   
				string sort = WC.GetXML(str, "xs");
				int len = Convert.ToInt32(WC.GetXML(str, "xl"));
				byte[] getStream = new byte[len];
				int idx = 0;

				while (len > idx)
				{
					idx = idx + RootSocket.Receive(getStream, idx, len-idx, 0);
				}

				if (FormHash.Contains(WC.MakeXML("WinBoard", sort)))
				{
					((WinBoard)FormHash[WC.MakeXML("WinBoard", sort)]).OnILOVEAICACAXME(sort, getStream);
				}
			}
		}

		public void RootILOVEAICACAXFI(string str)
		{
			lock(this)
			{   
				string changeFileName = WC.GetXML(str, "xc");
				int fileLen = Convert.ToInt32(WC.GetXML(str, "xl"));
				byte[] fileStream = new byte[fileLen];
				int idx = 0;

				while (fileLen > idx)
				{
					idx = idx + RootSocket.Receive(fileStream, idx, fileLen-idx, 0);
				}

				FileStream fs = new FileStream(changeFileName, FileMode.Create);
				fs.Write(fileStream,0,fileLen);
				fs.Close();

				string fileName = new FileInfo(changeFileName).Name;
				MessageBox.Show("File Name : " + fileName + "  Received successfully.");
			}
		}

		public void RootILOVEAICACAERR(string str)
		{
			lock(this)
			{
				string threadID = WC.RemoteToThread(WC.GetXML(str, "eid"));
			
				if (threadID != null && FormHash.Contains(threadID))
				{
					((WinReceive)FormHash[threadID]).OnILOVEAICACAERR(str);
				}
				else
				{
					MessageBox.Show(this, WC.GetXML(str, "er"));
				}
			}
		}

		public void RootILOVEAICACACHA(string str)
		{
			lock(this)
			{
				this.AddChatText(WC.GetXML(str, "ln"), WC.GetNextXML(str, "body"));
			}
		}

		public WinRoot pWinRoot
		{
			set
			{
				this.xWinRoot = value;
			}
		}

		public Socket pRootSocket
		{
			set
			{
				this.RootSocket = value;
				NetworkStream stream = new NetworkStream(RootSocket);
				this.SocketWriter = new StreamWriter(stream);
			}
		}

		public string pMainStatus
		{
			set
			{
				this.statusBar.Panels[0].Text = value;
			}
		}

		public string pProcessStatus
		{
			set
			{
				this.statusBar.Panels[1].Text = value;
			}
		}

		public string pLocalID
		{
			set
			{
				this.localID = value;
			}
		}

		public static void Main(string[] args) 
		{
			Application.Run(new WinClient());
		}
	}
}
